# Copyright 2019 Huawei Technologies Co., Ltd
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

"""
################################################

Testcase_PrepareCondition:

Testcase_TestSteps:

Testcase_ExpectedResult:

"""
import os

from base import TestBase
import pytest
from test_run.maximum_run import maximum_run

############################################################
# TestCase= class: put to tests/*/
############################################################


class TestCase(TestBase):
    def setup(self):
        case_name = "test_maximum_001"
        case_path = os.getcwd()

        # params init
        self.params_init(case_name, case_path)
        self.caseresult = True
        self._log.info("============= {0} Setup case============".format(self.casename))
        self.testarg = [
            # testflag,opfuncname,testRunArgs, setdimArgs
            ("maximum_001", maximum_run, ([4, 3], [4, 3], 'float16')),
            ("maximum_002", maximum_run, ([4, 3], [4, 3], 'float32')),
            ("maximum_003", maximum_run, ([4, 3], [4, 3], 'int32')),
            ("maximum_004", maximum_run, ([4, 3], [4, 3], 'int8')),
            ("maximum_005", maximum_run, ([4, 3], [4, 3], 'uint8')),
        ]
        self.testarg_rpc_cloud = [
            # testflag,opfuncname,testRunArgs, setdimArgs
            ("maximum_006", maximum_run, ([4, 3], [4, 3], 'float32')),
            ("maximum_007", maximum_run, ([4, 3], [4, 3], 'int8')),
            ("maximum_008", maximum_run, ([4, 3], [4, 3], 'int32')),
            ("maximum_009", maximum_run, ([4, 3], [4, 3], 'uint8')),
            ("maximum_010", maximum_run, ([4, 3], [4, 3], 'float16')),
        ]
        return

    @pytest.mark.rpc_mini
    @pytest.mark.level0
    @pytest.mark.env_onecard
    @pytest.mark.platform_x86_ascend_training
    def test_run(self):
        """
        run case.#
        :return:
        """
        self.common_run(self.testarg)

    @pytest.mark.rpc_cloud
    @pytest.mark.env_onecard
    @pytest.mark.platform_x86_ascend_training
    def test_run_rpc_cloud(self):
        """
        run case.#
        :return:
        """
        self.common_run(self.testarg_rpc_cloud)

    def teardown(self):
        """
        clean environment
        :return:
        """
        self._log.info("============= {0} Teardown============".format(self.casename))
        return
